import { OpenAPIV3 } from 'openapi-types';
import { DCPlugin } from '../types/declarative-config';
import { BasicAuthPlugin, KeyAuthPlugin, OpenIDConnectPlugin } from '../types/kong';
import { OA3Operation, OA3SecurityScheme, OpenApi3Spec } from '../types/openapi3';
export declare function generateSecurityPlugins(op: OA3Operation | null, api: OpenApi3Spec, tags: string[]): DCPlugin[];
export declare const generateApiKeySecurityPlugin: (scheme: OpenAPIV3.ApiKeySecurityScheme) => KeyAuthPlugin;
export declare const generateBasicAuthPlugin: (scheme: OpenAPIV3.HttpSecurityScheme) => BasicAuthPlugin;
export declare const generateOpenIdConnectSecurityPlugin: (scheme: OpenAPIV3.OpenIdSecurityScheme, args: string[]) => OpenIDConnectPlugin;
export declare const generateOAuth2SecurityPlugin: () => OpenIDConnectPlugin;
export declare function generateSecurityPlugin(scheme: OA3SecurityScheme | null, args: string[], tags: string[]): KeyAuthPlugin | BasicAuthPlugin | OpenIDConnectPlugin | null;
//# sourceMappingURL=security-plugins.d.ts.map