import { Plugin } from './kong';
import { Pluggable, Taggable } from './outputs';
export declare type DCPlugin = Plugin;
export interface DCRoute extends Taggable, Pluggable {
    methods: string[];
    name: string;
    paths: string[];
    strip_path: boolean;
}
export interface DCService extends Taggable, Pluggable {
    host: DCUpstream['name'];
    name: string;
    path: string | null;
    port: number;
    protocol: string | undefined;
    routes: DCRoute[];
}
export interface DCTarget extends Taggable {
    target: string;
}
export interface DCUpstream extends Taggable {
    name: string;
    targets: DCTarget[];
}
export interface DeclarativeConfig {
    _format_version: '1.1';
    services: DCService[];
    upstreams?: DCUpstream[];
}
//# sourceMappingURL=declarative-config.d.ts.map